# ruff: noqa
# generated by datamodel-codegen:
#   filename:  event_page.json

from __future__ import annotations

from typing import Dict, List, TypedDict, Union

from typing_extensions import NotRequired


class PartialEventPage(TypedDict):
    data: Dict[str, List]
    """
    The actual measurement data
    """
    filled: NotRequired[Dict[str, List[Union[bool, str]]]]
    """
    Mapping each of the keys of externally-stored data to an array containing the boolean False, indicating that the data has not been loaded, or to foreign keys (moved here from 'data' when the data was loaded)
    """
    time: List[float]
    """
    Array of Event times. This maybe different than the timestamps on each of the data entries
    """
    timestamps: Dict[str, List]
    """
    The timestamps of the individual measurement data
    """


class EventPage(PartialEventPage):
    """
    Page of documents to record a quanta of collected data
    """

    descriptor: str
    """
    The UID of the EventDescriptor to which all of the Events in this page belong
    """
    seq_num: List[int]
    """
    Array of sequence numbers to identify the location of each Event in the Event stream
    """
    uid: List[str]
    """
    Array of globally unique identifiers for each Event
    """
