# ruff: noqa
# generated by datamodel-codegen:
#   filename:  resource.json

from __future__ import annotations

from typing import Any, Dict, Literal, TypedDict

from typing_extensions import NotRequired


class PartialResource(TypedDict):
    resource_kwargs: Dict[str, Any]
    """
    Additional argument to pass to the Handler to read a Resource
    """
    resource_path: str
    """
    Filepath or URI for locating this resource
    """
    root: str
    """
    Subset of resource_path that is a local detail, not semantic.
    """
    spec: str
    """
    String identifying the format/type of this Resource, used to identify a compatible Handler
    """
    uid: str
    """
    Globally unique identifier for this Resource
    """


class Resource(PartialResource):
    """
    Document to reference a collection (e.g. file or group of files) of
    externally-stored data
    """

    path_semantics: NotRequired[Literal["posix", "windows"]]
    """
    Rules for joining paths
    """
    run_start: NotRequired[str]
    """
    Globally unique ID to the run_start document this resource is associated with.
    """
