# ruff: noqa
# generated by datamodel-codegen:
#   filename:  stream_resource.json

from __future__ import annotations

from typing import Any, Dict, TypedDict

from typing_extensions import NotRequired


class StreamResource(TypedDict):
    """
    Document to reference a collection (e.g. file or group of files) of
    externally-stored data streams
    """

    data_key: str
    """
    A string to show which data_key of the Descriptor are being streamed
    """
    mimetype: str
    """
    String identifying the format/type of this Stream Resource, used to identify a compatible Handler
    """
    parameters: Dict[str, Any]
    """
    Additional keyword arguments to pass to the Handler to read a Stream Resource
    """
    run_start: NotRequired[str]
    """
    Globally unique ID to the run_start document this Stream Resource is associated with.
    """
    uid: str
    """
    Globally unique identifier for this Stream Resource
    """
    uri: str
    """
    URI for locating this resource
    """
